package at.jku.fim.datalinksimulation.layer1.wire.damagedwire;

import at.jku.fim.datalinksimulation.layer1.data.RawData;

/**
 * <p>Title: OSI Simulation Framework</p>
 * <p>Copyright: (c) 2004-05</p>
 * <p>Company: FIM@JKU, www.fim.uni-linz.ac.at</p>
 * Must be implemented by concrete damaging strategies.
 * @author Andreas Putzinger
 * @version $Id: DamagingStrategy.java,v 1.1 2005/10/27 13:10:07 aputzinger Exp $
 */

public interface DamagingStrategy  {

    /**
     * Implementations of this method change the frame data; Damaged cables and wires are simulated.
     * @param data The original frame data
     * @return Returns possibly modified or corrupted frame data or null, if strategy eats up whole frame
     */
	public RawData damageData(RawData data);

}
