package at.jku.fim.datalinksimulation.networkstack.incoming;

import at.jku.fim.datalinksimulation.layer1.data.RawData;
import at.jku.fim.datalinksimulation.networkstack.NetworkFilter;
import at.jku.fim.datalinksimulation.networkstack.NetworkStackParameters;
import at.jku.fim.datalinksimulation.utils.Logger;

/**
 * <p>Title: OSI Simulation Framework</p>
 * <p>Copyright: (c) 2004-05</p>
 * <p>Company: FIM@JKU, www.fim.uni-linz.ac.at</p>
 * @author Andreas Putzinger
 * @version $Id: DecodingNetworkFilter.java,v 1.1 2005/10/27 13:10:11 aputzinger Exp $
 */

public interface DecodingNetworkFilter extends NetworkFilter {

    /**
     * Performs a decoding step within the incoming network stack
     * @param params stack parameters
     * @param data Data from the layer below (or from previous filter in this layer) 
     * @param logger Logger instance
     * @return Returns decoded raw data or null, if data is consumed and not delivered further up
     */
    public RawData decode(NetworkStackParameters params, RawData data,
            Logger logger);

    /**
     * @return Short description of this filter implementation
     */
    public String getDescription();

}