package at.jku.fim.datalinksimulation.scenario.Bully;

import java.awt.Dimension;
import java.awt.Toolkit;

import javax.swing.UIManager;

import at.jku.fim.datalinksimulation.scenario.Bully.gui.BullySimulationFrame;

/**
 * <p>Bully Algorithm Simulation Framework</p>
 * <p>Copyright: (c) 2004</p>
 * <p>Company: FIM@JKU, www.fim.uni-linz.ac.at</p>
 * @author Andreas Putzinger
 * @author Michael Sonntag
 * @version $Id$
 */
public class BullySimulationApplication {

    private boolean packFrame = false;

    private static BullySimulationFrame frame = null;

    //Construct the application
    public BullySimulationApplication() {
        frame = new BullySimulationFrame();
        //Validate frames that have preset sizes
        //Pack frames that have useful preferred size info, e.g. from their layout
        if (packFrame) {
            frame.pack();
        } else {
            frame.validate();
        }
        //Center the window
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        // Dimension frameSize = frame.getSize();
        // set frameSize manually
        Dimension frameSize = new Dimension(811,500);
        frame.setSize(frameSize);
        frame.setResizable(false);
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2,
                (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
    }

    //Main method
    public static void main(String[] args) {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            e.printStackTrace();
        }
        new BullySimulationApplication();
    }
}