/*
 * BullyPanel.java
 *
 * Created on 10. November 2004, 16:16
 */

package at.jku.fim.datalinksimulation.scenario.Bully.gui;

import java.awt.Color;

import at.jku.fim.datalinksimulation.layer7.Bully.BullyApplication;

/** Panel for Visualization of the Bully application
 *
 * @author Michael Sonntag
 * @version $ Id:1.0 $
 */
public class BullyPanel extends javax.swing.JPanel {
        
	private static final long serialVersionUID = 1L;

	/** Our application */
    private BullyApplication application;
    
    /** Creates new form BullyPanel */
    public BullyPanel() {
        initComponents();
        setState(BullyApplication.BULLY_STATE_UNKNOWN);
    }
    
    /** Set the application; so we can get the station, ...
     * @param application the application
     */    
    public void setApp(final BullyApplication application) {
        this.application=application;
        stationIDLabel.setText("Station ID: "+application.getStationId());        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        stationIDLabel = new javax.swing.JLabel();
        masterLabel = new javax.swing.JLabel();
        stateLabel = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        activeButton = new javax.swing.JToggleButton();

        setLayout(new java.awt.GridBagLayout());

        setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        stationIDLabel.setBackground(java.awt.Color.magenta);
        stationIDLabel.setText("Station ID: <?>");
        stationIDLabel.setOpaque(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 100.0;
        add(stationIDLabel, gridBagConstraints);

        masterLabel.setBackground(java.awt.Color.gray);
        masterLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        masterLabel.setText("Unknown");
        masterLabel.setOpaque(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 5;
        gridBagConstraints.ipady = 5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(masterLabel, gridBagConstraints);

        stateLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        stateLabel.setText("State:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 0);
        add(stateLabel, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        activeButton.setBackground(java.awt.Color.green);
        activeButton.setText("Active");
        activeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                activeButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.ipadx = 5;
        jPanel1.add(activeButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 99;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 100.0;
        gridBagConstraints.weighty = 100.0;
        add(jPanel1, gridBagConstraints);

    }//GEN-END:initComponents

    private void activeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_activeButtonActionPerformed
        if(activeButton.isSelected()) {
            application.terminate();
            activeButton.setBackground(Color.red);
            activeButton.setText("Failure");
        } else {
            new Thread(application).start();
            activeButton.setBackground(Color.green);
            activeButton.setText("Active");
        }        
    }//GEN-LAST:event_activeButtonActionPerformed
    
    /** Show the state according to the internal state of the Bully application 
     * @param state the new state
     */
    public void setState(final int state) {
        switch(state) {
            case BullyApplication.BULLY_STATE_INIT:
                masterLabel.setText("Initializing");
                masterLabel.setBackground(Color.WHITE);
            break;
            case BullyApplication.BULLY_STATE_ELECTION:
                masterLabel.setText("Electing");
                masterLabel.setBackground(Color.LIGHT_GRAY);
            break;
            case BullyApplication.BULLY_STATE_WAIT:
                masterLabel.setText("Waiting");
                masterLabel.setBackground(Color.GRAY);
            break;
            case BullyApplication.BULLY_STATE_SLAVE:
                masterLabel.setText("Slave to "+application.getMasterID());
                masterLabel.setBackground(new Color(175,120,0)); // Brown
            break;
            case BullyApplication.BULLY_STATE_MASTER:
                masterLabel.setText("Master");
                masterLabel.setBackground(Color.ORANGE);
            break;
            default:
                masterLabel.setText("Unknown");
                masterLabel.setBackground(Color.RED);
            break;
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JToggleButton activeButton;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel masterLabel;
    private javax.swing.JLabel stateLabel;
    private javax.swing.JLabel stationIDLabel;
    // End of variables declaration//GEN-END:variables
    
}
