package at.jku.fim.datalinksimulation.scenario.gui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.util.Iterator;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.TitledBorder;

import at.jku.fim.datalinksimulation.utils.Logger;

/**
 * <p>Title: OSI Simulation Framework</p>
 * <p>Copyright: (c) 2004-05</p>
 * <p>Company: FIM@JKU, www.fim.uni-linz.ac.at</p>
 * @author Andreas Putzinger
 * @version $Id: LogPanel.java,v 1.1 2005/10/27 13:10:08 aputzinger Exp $
 */

public class LogPanel extends JPanel {

	private static final long serialVersionUID = -3282690487383726591L;

	BorderLayout borderLayout1 = new BorderLayout();

    JPanel selectPanel = new JPanel();

    JPanel jPanel2 = new JPanel();

    JPanel jPanel3 = new JPanel();

    JComboBox logSelector = new JComboBox();

    BorderLayout borderLayout2 = new BorderLayout();

    JLabel selectLogComponentLabel = new JLabel();

    JScrollPane jScrollPane1 = new JScrollPane();

    BorderLayout borderLayout3 = new BorderLayout();

    JTextArea log = new JTextArea();

    Component component1;

    JButton clearThisLogButton = new JButton();

    JButton clearLogsButton = new JButton();

    Component component2;

    TitledBorder titledBorder1;

    DefaultComboBoxModel logModel = new DefaultComboBoxModel();

    public LogPanel() {
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    void jbInit() throws Exception {
        component1 = Box.createVerticalStrut(8);
        component2 = Box.createVerticalStrut(8);
        titledBorder1 = new TitledBorder("");
        this.setLayout(borderLayout1);
        selectPanel.setLayout(borderLayout2);
        selectLogComponentLabel.setText("Select network component:");
        jPanel3.setLayout(borderLayout3);
        jPanel2.setLayout(null);
        clearThisLogButton.setBounds(new Rectangle(5, 48, 97, 25));
        clearThisLogButton.setText("Clear this log");
        clearThisLogButton
                .addActionListener(new LogPanel_clearThisLogButton_actionAdapter(
                        this));
        clearLogsButton.setBounds(new Rectangle(5, 18, 97, 25));
        clearLogsButton.setText("Clear all logs");
        clearLogsButton
                .addActionListener(new LogPanel_clearLogsButton_actionAdapter(
                        this));
        log.setText("");
        log.setEditable(false);
        this.setBorder(BorderFactory.createRaisedBevelBorder());
        logSelector.addActionListener(new LogPanel_logSelector_actionAdapter(
                this));
        jPanel2.setPreferredSize(new Dimension(107, 78));
        jPanel2.setVerifyInputWhenFocusTarget(true);
        component2.setBounds(new Rectangle(5, 5, 97, 8));
        this.add(selectPanel, BorderLayout.NORTH);
        this.add(jPanel2, BorderLayout.EAST);
        this.add(jPanel3, BorderLayout.CENTER);
        selectPanel.add(logSelector, BorderLayout.CENTER);
        selectPanel.add(selectLogComponentLabel, BorderLayout.WEST);
        jPanel3.add(jScrollPane1, BorderLayout.CENTER);
        jScrollPane1.getViewport().add(log, null);
        selectPanel.add(component1, BorderLayout.SOUTH);
        jPanel2.add(clearThisLogButton, null);
        jPanel2.add(clearLogsButton, null);
        jPanel2.add(component2, null);
        logSelector.setModel(logModel);
        updateLogs();
    }

    private void _addLogger(Logger currentLogger) {
    	logModel.addElement(currentLogger);
        for (Iterator it = currentLogger.getChildrenLoggers().iterator(); it.hasNext(); ) {
            _addLogger((Logger)it.next());
        }
    }
    
    public void updateLogs() {
        logModel.removeAllElements();
        for (Iterator it = Logger.getRootLoggers().iterator(); it.hasNext(); ) {
            _addLogger((Logger)it.next());
        }
        showSelectedLog();
    }

    public void showSelectedLog() {
        Object obj = logModel.getSelectedItem();
        if (obj != null) {
            Logger logger = (Logger) obj;
            log.setText(logger.getLog());
        }
    }

    void clearLogsButton_actionPerformed(ActionEvent e) {
        Logger.clearAllLogs();
        showSelectedLog();
    }

    void logSelector_actionPerformed(ActionEvent e) {
        showSelectedLog();
    }

    void clearThisLogButton_actionPerformed(ActionEvent e) {
        Object obj = logModel.getSelectedItem();
        if (obj != null) {
            Logger logger = (Logger) obj;
            logger.clear();
            showSelectedLog();
        }
    }
}

class LogPanel_clearLogsButton_actionAdapter implements
        java.awt.event.ActionListener {
    LogPanel adaptee;

    LogPanel_clearLogsButton_actionAdapter(LogPanel adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.clearLogsButton_actionPerformed(e);
    }
}

class LogPanel_logSelector_actionAdapter implements
        java.awt.event.ActionListener {
    LogPanel adaptee;

    LogPanel_logSelector_actionAdapter(LogPanel adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.logSelector_actionPerformed(e);
    }
}

class LogPanel_clearThisLogButton_actionAdapter implements
        java.awt.event.ActionListener {
    LogPanel adaptee;

    LogPanel_clearThisLogButton_actionAdapter(LogPanel adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.clearThisLogButton_actionPerformed(e);
    }
}