package at.jku.fim.datalinksimulation.scenario.gui;

import javax.swing.UIManager;
import java.awt.*;

/**
 * <p>Title: OSI Simulation Framework</p>
 * <p>Copyright: (c) 2004-05</p>
 * <p>Company: FIM@JKU, www.fim.uni-linz.ac.at</p>
 * @author Andreas Putzinger
 * @version $Id: SimulationApplication.java,v 1.1 2005/10/27 13:10:08 aputzinger Exp $
 */

public class SimulationApplication {
    boolean packFrame = false;

    public static SystemScenarioGUI frame = null;

    //Construct the application
    public SimulationApplication() {
        frame = new SystemScenarioGUI();
        //Validate frames that have preset sizes
        //Pack frames that have useful preferred size info, e.g. from their layout
        if (packFrame) {
            frame.pack();
        } else {
            frame.validate();
        }
        //Center the window
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        // Dimension frameSize = frame.getSize();
        // set frameSize manually
        Dimension frameSize = new Dimension(820, 500);
        frame.setSize(frameSize);
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2,
                (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
    }

    //Main method
    public static void main(String[] args) {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            e.printStackTrace();
        }
        new SimulationApplication();
    }
}